#!/usr/bin/python2
# -*- coding: utf-8 -*-

# Import modules for CGI handling
import cgi
import datetime
import os.path
import distutils.dir_util
import json

# Create instance of FieldStorage
form = cgi.FieldStorage()

# Declarations
name = form.getvalue('name', '')
email = form.getvalue('email', '')
username = form.getvalue('username', '').lower()
course_code = form.getvalue('course', '').upper()
modality = (
    form.getvalue('modality').lower()
    if form.getvalue('modality')
    else 'MODALITY'
)
instructor = form.getvalue('instructor', 'INSTRUCTOR')
uuid = form.getvalue('uuid')
uuid_short = uuid[:8] if uuid else 'UUID'

resultsdir = "/var/www/results/roster/"


def init():
    try:
        write_file()
        respond(True)

    except Exception as e:
        respond(False, "403 Forbidden", str(e))


# write results to file
def write_file():
    date = datetime.date.today().strftime('%Y%m%d')

    filename = "%s-roster-%s-%s-%s-%s.txt" % (
        date,
        course_code or 'COURSE',
        modality,
        instructor,
        uuid_short
    )

    distutils.dir_util.mkpath(resultsdir)

    if (not os.path.isfile('%s%s' % (resultsdir, filename))):
        with open('%s%s' % (resultsdir, filename), 'a') as fileOutput:
            fileOutput.write("name	email	provider	enroll_reason	enroll_reason_sponsor_value	enroll_reason_other_ad_value	enroll_reason_conference_value	enroll_reason_other_value	version	organization	organization_other_value	company_revenue	company_systems	os_experience	preassess	purchase_process	future_training	pubs_sites_read	pubs_sites_read_other_mag	pubs_sites_read_other_site	receive_opt_in\n")

    with open('%s%s' % (resultsdir, filename), 'a') as fileOutput:
        fileOutput.write(name)
        fileOutput.write("	")
        fileOutput.write(email)
        fileOutput.write("	")
        fileOutput.write("Red Hat	referral					1.1	business 10001+		100+ million	51+	REMOVED	REMOVED			REMOVED			no")
        fileOutput.write("\n")


def respond(accept=True, status="200 OK", msg='success'):
    print "Access-Control-Allow-Origin: *"
    print "Content-type: application/json"
    print "Status: %s" % status
    print
    response = {
        'result': msg
    }
    print(json.JSONEncoder().encode(response))


init()
